
// DNGConverterDlg.h :  
//

#pragma once
#pragma comment(lib, "Wtsapi32.lib")

#include "afxcmn.h"
#include "DNG.h"
#include "afxwin.h"
#include "Wtsapi32.h"
#include <Dbt.h>
#include <vector>
#include <iostream>

#include "DNGLightRoomDlg.h"
#include "DNGConvertCompleteDlg.h"
#include "DNGNotSupportDlg.h"
#include "DNGMemoryLackDlg.h"
#include "DNGSameNameDlg.h"
#include "DNGConvertErrorDlg.h"
#include "DNGUsbErrorDlg.h"
#include "MyListCtrl.h"
#include "BitmapButtonTrans.h"

#include "./QtTest/QtTest/dngfactory.h"


using namespace std;

// CDNGConverterDlg ȭ 
#define STORAGE_TEST 40



class CDNGConverterDlg : public CDialogEx
{
// Դϴ.

public:
	CDNGConverterDlg(CWnd* pParent = NULL);	// ǥ Դϴ.

// ȭ  Դϴ.
	enum { IDD = IDD_DNGCONVERTER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV Դϴ.


// Դϴ.
	HICON m_hIcon;

	//  ޽  Լ
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

	//-------- header  
	int  m_HeaderId;
	bool m_HeaderState;
	HWND header;
	//--------

	CStatic m_areaDivider;
	CStatic m_fileListText;
	CStatic m_savePosText;
	CStatic m_afterConvertText;
	CBitmapButtonTrans m_folderSelectButton;
	CBitmapButtonTrans m_folderOpenButton;
	CBitmapButtonTrans m_adobeCheckButton;

public:
	CBitmapButtonTrans m_fileAddButton;
	CBitmapButtonTrans m_fileRemoveButton;
	CBitmapButtonTrans m_convertButton;
	CBitmapButtonTrans m_convertFolderButton;
	int  menuSelectItem;
	LVCOLUMNW name_col, path_col;
	bool m_bSortAscending;
	int m_nSortColumn;

	DNGConvertCompleteDlg ccd;
	DNGMemoryLackDlg mld;
	DNGUsbErrorDlg ued;
	DNGSameNameDlg snd;
	DNGConvertErrorDlg ced;
	DNGNotSupportDlg nsd;
	DNGLightRoomDlg lrd;
	
	//-------- OSD method
	void FindFilesInFolder(CString filePath);
	CString CropFileName(CString filePath);
	BOOL CheckStorage(int tempPathNum, int fileSize, int checkFiles);
	void SetInterfaceText();
	void SetInterfacePos();
	void SetInterfaceButton();
	void CheckBoxControlHeader();
	int ControlHeaderCheckbox(bool check);
	//-------- 

	vector<DNG> mDngFileList;
	CString saveFileName;
	CString saveFilePath;

	MyListCtrl m_fileList;
	CImageList imgList;

	CEdit m_savePath;

	CBitmap c1, c2, c3;


	//-------- thread  
	CWinThread *cwt;
	BOOL threadRun;
	int n_ThreadWork;
	int n_ThreadSingleSelected;
	typedef struct ThreadParam
	{
		CListCtrl* cCtrl;
		CEdit* outPath;
		int singleSelect;
		int startPoint;
	}t_Param;
	t_Param tParam;
	//-------- 

	//====================================


	afx_msg void OnBnClickedDelFile();
	afx_msg void OnBnClickedSelFile();
	afx_msg void OnBnClickedChangeFolder();
	afx_msg void OnBnClickedOpenFolder();
	afx_msg void OnBnClickedConvert();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBnClickedAdobeCheck();
	afx_msg void OnNMRClickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnMRemovefile();
	afx_msg void OnHdnItemStateIconClickList1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMClickList1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnMConvert();
	afx_msg void OnBnClickedCheckOpenFolder();
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	
	virtual BOOL DestroyWindow();
	afx_msg void OnLvnHotTrackList1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDoubleClickList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnColumnclickList(NMHDR *pNMHDR, LRESULT *pResult);
};



static LANGID language = 0;
UINT ConvertThreadFunc(LPVOID pParam);
char FirstDriveFromMask( ULONG unitmask );
static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParam);
static bool subDialogMoved=false;
static int subDialogX=0, subDialogY=0;