// ProgressListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "ProgressList.h"
#include "ProgressListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProgressListCtrl

CProgressListCtrl::CProgressListCtrl()
{
}

CProgressListCtrl::~CProgressListCtrl()
{
  CProgressEntry* pProgEntry=0;
  int Index=0;
  POSITION pos = m_ProgEntries.GetStartPosition();
  while (pos != NULL) {
    m_ProgEntries.GetNextAssoc(pos, Index, pProgEntry);
    if (pProgEntry) delete pProgEntry;
  }
  m_ProgEntries.RemoveAll();
}


BEGIN_MESSAGE_MAP(CProgressListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CProgressListCtrl)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_SIZE()
	ON_WM_WINDOWPOSCHANGED()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgressListCtrl message handlers

void CProgressListCtrl::CreateProgress(int Index)
{
  // can only create progress for an existing item
  if (Index >= GetItemCount())
    return;
  CProgressEntry* ProgEntry = new CProgressEntry(Index,3);
  CRect ItemRectBtn;

  GetSubItemRect(Index, ProgEntry->m_SubIndex+1, LVIR_BOUNDS, ItemRectBtn);

  int leftBtn   = ItemRectBtn.left;
  int topBtn	= ItemRectBtn.top;
  int rightBtn  = ItemRectBtn.right;
  int bottomBtn = ItemRectBtn.bottom;

 // (ProgEntry->m_Prog).Create(PBS_SMOOTH | WS_CHILD | WS_VISIBLE, CRect(left, top, right, bottom), this,1);
 // (ProgEntry->m_Prog).SetRange(0, 100);
  //(ProgEntry->m_Prog).SetPos(0);


  (ProgEntry->m_Button).Create(_T("X"), WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 
	  CRect(leftBtn, topBtn, rightBtn, bottomBtn), this, Index+1000);
  m_ProgEntries.SetAt(Index+1000,ProgEntry);

 // m_ProgEntries[Index] = ProgEntry;
}

void CProgressListCtrl::RemoveAllProgress()
{
	CProgressEntry* ProgEntry=0;
	int Index=0;
	POSITION pos = m_ProgEntries.GetStartPosition();
	while (pos != NULL) {
		m_ProgEntries.GetNextAssoc(pos, Index, ProgEntry);
	}
	m_ProgEntries.RemoveAll();
}

void CProgressListCtrl::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	ResizeProg();
	CListCtrl::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CProgressListCtrl::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	ResizeProg();	
	CListCtrl::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CProgressListCtrl::OnSize(UINT nType, int cx, int cy) 
{
	ResizeProg();
	CListCtrl::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here
  
}

void CProgressListCtrl::ResizeProg()
{
  CRect ItemRect;
  CRect ItemRectBtn;
  CProgressEntry* ProgEntry=0;
  int Index=0;
  POSITION pos = m_ProgEntries.GetStartPosition();
  while (pos != NULL) {
    
	m_ProgEntries.GetNextAssoc(pos, Index, ProgEntry);
   
	GetSubItemRect(ProgEntry->m_Index, ProgEntry->m_SubIndex+1, LVIR_BOUNDS, ItemRectBtn);

	int leftBtn = ItemRectBtn.left;
	int topBtn = ItemRectBtn.top;
	int rightBtn = ItemRectBtn.right;
	int bottomBtn = ItemRectBtn.bottom;

	(ProgEntry->m_Button).DestroyWindow();
	(ProgEntry->m_Button).MoveWindow(leftBtn, topBtn, (rightBtn - leftBtn), (bottomBtn - topBtn));
  }
}

void CProgressListCtrl::OnWindowPosChanged(WINDOWPOS FAR* lpwndpos) 
{
	CListCtrl::OnWindowPosChanged(lpwndpos);
	ResizeProg();
}

void CProgressListCtrl::InitHdr()
{
	m_AdvHdr.Init(GetHeaderCtrl());
}

CProgressListCtrl::CProgressEntry::CProgressEntry(int Index, int SubIndex) :
m_Index(Index), m_SubIndex(SubIndex)
{
}

CProgressListCtrl::CProgressEntry::~CProgressEntry()
{
}


BOOL CProgressListCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	int index =LOWORD(wParam) - 1000;
	
	DeleteProgressItem(index);

	return CListCtrl::OnCommand(wParam, lParam);
}
BOOL CProgressListCtrl::DeleteProgressItem(int nItem)
{
	CString str;
	
	CProgressEntry* pProgEntry=0;
    int index=0;
	int entriesNum = m_ProgEntries.GetCount();
    POSITION pos = m_ProgEntries.GetStartPosition();
	int delIndex = -1;
  
	while (pos != NULL) {
		m_ProgEntries.GetNextAssoc(pos, index, pProgEntry);


		if(index-1000 == nItem)
		{
			pProgEntry->~CProgressEntry();
			m_ProgEntries.RemoveKey(index);
			delIndex = index;
			break;
		}
	}
	pos = m_ProgEntries.GetStartPosition();
	while(pos!=NULL)
	{
		m_ProgEntries.GetNextAssoc(pos, index, pProgEntry);
		str.Format(L"%d ",index);
		MessageBox(str,L"Button",MB_OK);
		if(delIndex != -1 && delIndex < index)
		{
			CRect ItemRectBtn;

			GetSubItemRect(index-1, pProgEntry->m_SubIndex+1, LVIR_BOUNDS, ItemRectBtn);

			int leftBtn   = ItemRectBtn.left;
			int topBtn	= ItemRectBtn.top;
			int rightBtn  = ItemRectBtn.right;
			int bottomBtn = ItemRectBtn.bottom;

			(pProgEntry->m_Button).MoveWindow(leftBtn, topBtn, (rightBtn - leftBtn), (bottomBtn - topBtn));
			m_ProgEntries.SetAt(index-1,pProgEntry);

		}
	}
	//ResizeProg();
	return this->DeleteItem(nItem);
}